variables:
  PACKAGE_OUTPUT_DIR: nuget
  PACKAGE_UNSTABLE_SUFFIX: beta
  GITLAB_NUGET_REPOSITORY_URL: https://gitlab.com/api/v4/projects/19668281/packages/nuget/index.json
  GITLAB_NUGET_REPOSITORY_KEY: $NUGET_GITLAB_API_KEY
  NUGET_ORG_NUGET_REPOSITORY_URL: https://api.nuget.org/v3/index.json
  NUGET_ORG_NUGET_REPOSITORY_KEY: $NUGET_NUGETORG_API_KEY

image: mcr.microsoft.com/dotnet/core/sdk:3.1

stages:
  - build
  - test
  - package
  - delivery

build:
  stage: build
  script:
    - dotnet restore --no-cache --force
    - dotnet build -c Release --no-restore
  artifacts:
    paths:
    - test
    expire_in: 1 hour

unit_tests:
  stage: test
  script: dotnet vstest test/*UnitTests/bin/Release/**/*UnitTests.dll --Blame
  rules:
    - exists:
      - test/*UnitTests/*UnitTests.csproj

integration_tests:
  stage: test
  script: dotnet vstest test/*IntegrationTests/bin/Release/**/*IntegrationTests.dll --Blame
  rules:
    - exists:
      - test/*IntegrationTests/*IntegrationTests.csproj

package_beta:
  stage: package
  script:
    - dotnet pack *.sln --configuration Release --output $PACKAGE_OUTPUT_DIR --version-suffix $PACKAGE_UNSTABLE_SUFFIX --include-source --include-symbols -p:SymbolPackageFormat=snupkg
  rules:
    - if: $CI_COMMIT_BRANCH != "master"
  artifacts:
    paths:
    - $PACKAGE_OUTPUT_DIR/
    expire_in: 1 hour
    
package_stable:
  stage: package
  script:
    - dotnet pack *.sln --configuration Release --output $PACKAGE_OUTPUT_DIR --include-symbols -p:SymbolPackageFormat=snupkg
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  artifacts:
    paths:
      - $PACKAGE_OUTPUT_DIR/
    expire_in: 1 hour

gitlab_repository:
  stage: delivery
  script:
    - dotnet nuget push $PACKAGE_OUTPUT_DIR/**/*.nupkg --source $GITLAB_NUGET_REPOSITORY_URL --api-key $GITLAB_NUGET_REPOSITORY_KEY --skip-duplicate

nuget_org_repository:
  stage: delivery
  script:
    - dotnet nuget push $PACKAGE_OUTPUT_DIR/**/*.nupkg --source $NUGET_ORG_NUGET_REPOSITORY_URL --api-key $NUGET_ORG_NUGET_REPOSITORY_KEY --skip-duplicate
